import cv2
import os

# Define the folder path where the frames are stored
folder_path = './dataset-tray10/5_5'

# Define the output video file name
out_video_file = 'video.mp4'

# Get the list of all frames in the folder
frames = [f for f in os.listdir(folder_path) if f.endswith('.png')]

# Sort the frames based on their names
frames.sort()

# Define the frames per second for the video
fps = 1

# Get the size of the first frame
frame = cv2.imread(os.path.join(folder_path, frames[0]))
frame_height, frame_width, _ = frame.shape

# Define the video codec and create the video writer
fourcc = cv2.VideoWriter_fourcc(*'mp4v')
video_writer = cv2.VideoWriter(out_video_file, fourcc, fps, (frame_width, frame_height))

# Loop through all frames and add them to the video
for frame_name in frames:
    frame = cv2.imread(os.path.join(folder_path, frame_name))
    video_writer.write(frame)

# Release the video writer
video_writer.release()



# # import libraries

# from numpy import expand_dims
# from keras.preprocessing.image import load_img
# from keras.preprocessing.image import img_to_array
# from keras.preprocessing.image import ImageDataGenerator

# image = "./image.png"
# # convert to numpy array
# data = img_to_array(image)

# # expand dimension to one sample
# samples = expand_dims(image, 0)

# # create image data augmentation generator
# datagen = ImageDataGenerator(width_shift_range=[-200,200])

# # create an iterator
# it = datagen.flow(samples, batch_size=1)
# fig, im = plt.subplots(nrows=1, ncols=3, figsize=(15,15))

# # generate batch of images
# for i in range(3):

#     # convert to unsigned integers
#     image = next(it)[0].astype('uint8')
 
#     # plot image
#     im[i].imshow(image)

#############################################################
### CONVERT FRAMES TO VIDEOS
#############################################################

# import cv2
# import os

# # Define the folder path where the frames are stored
# folder_path = './dataset-labeled/'

# sub_folder_list = os.listdir(folder_path)
# # print(sub_folder_list)
# # Define the output video file name


# for sub_folder in sub_folder_list:
    
#     sub_folder_path = folder_path + sub_folder
#     # Get the list of all frames in the folder
#     frames = [f for f in os.listdir(sub_folder_path) if f.endswith('.png')]

#     # # Sort the frames based on their names
#     frames.sort()


#     # Define the frames per second for the video
#     fps = 30

#     # Get the size of the first frame
#     frame = cv2.imread(os.path.join(sub_folder_path, frames[0]))
#     frame_height, frame_width, _ = frame.shape

#     # Define the video codec and create the video writer
#     fourcc = cv2.VideoWriter_fourcc(*'mp4v')
    
#     out_video_file = folder_path + 'germination/' + sub_folder + '.mp4'

#     print('sub_folder_path', sub_folder_path)
#     print('out_video_file', out_video_file)
    
#     video_writer = cv2.VideoWriter(out_video_file, fourcc, fps, (frame_width, frame_height))

#     # Loop through all frames and add them to the video
#     for frame_name in frames:
#         frame = cv2.imread(os.path.join(sub_folder_path, frame_name))
#         video_writer.write(frame)

#     # Release the video writer
#     video_writer.release()
