#############################################################
### CONVERT FRAMES TO VIDEOS
#############################################################

import cv2
import os

def split_array(array, index):
    return array[:index], array[index:]



def get_class_name_from_yolo_txt(file_path):
    if 'classes' in file_path:
        a = 5
    else:
        with open(file_path, 'r') as f:
            lines = f.readlines()
            # The class name is the first element in the first line of the file
            class_idx = int(lines[0].split()[0])

            if(class_idx == 1 ):
                frame = file_path.replace('txt', 'png')
                return frame
            return 0

def __init__():

    # Define the folder path where the frames are stored
    folder_path = './dataset-labeled/'
    


    sub_folder_list = os.listdir(folder_path)
    print(sub_folder_list)
    # Define the output video file name
    fps = 1

    for sub_folder in sub_folder_list:
        germinationFramePath = 0
        sub_folder_path = folder_path + sub_folder
        # Get the list of all frames in the folder
        labels = [f for f in os.listdir(sub_folder_path) if f.endswith('.txt')]
        frames = [f for f in os.listdir(sub_folder_path) if f.endswith('.png')]

        # # # Sort the frames based on their names
        # labels.sort()

        for count, label in enumerate(labels):
            data = get_class_name_from_yolo_txt(sub_folder_path + '/' + label)
            if(data != 0 and data != None):
                germinationFramePath = count
                break


        if(germinationFramePath - 1 >= 0):
            
            print(sub_folder)

            soilFrames, germFrames = split_array(frames, germinationFramePath - 1)

            # Get the size of the first frame
            germFrame = cv2.imread(os.path.join(sub_folder_path, germFrames[0]))
            frame_heightGerm, frame_widthGerm, _ = germFrame.shape
            
            # Get the size of the first frame
            soilFrame = cv2.imread(os.path.join(sub_folder_path, soilFrames[0]))
            frame_heightSoil, frame_widthSoil, _ = germFrame.shape

            # Define the video codec and create the video writer
            fourcc = cv2.VideoWriter_fourcc(*'mp4v')

            out_video_file_germ = './seedDB/germination/' + sub_folder + '.mp4'
            out_video_file_soil = './seedDB/soil/' + sub_folder + '.mp4'

            video_writerGerm = cv2.VideoWriter(out_video_file_germ, fourcc, fps, (frame_widthGerm, frame_heightGerm))
            video_writerSoil = cv2.VideoWriter(out_video_file_soil, fourcc, fps, (frame_widthSoil, frame_heightSoil))

            # Loop through all frames and add them to the video
            for frame_name in germFrames:
                frame = cv2.imread(os.path.join(sub_folder_path, frame_name))
                video_writerGerm.write(frame)
            
            # Loop through all frames and add them to the video
            for frame_name in soilFrames:
                frame = cv2.imread(os.path.join(sub_folder_path, frame_name))
                video_writerSoil.write(frame)

            # Release the video writer
            video_writerGerm.release()
            video_writerSoil.release()

__init__()