#############################################################
### CONVERT FRAMES TO VIDEOS
#############################################################

import cv2
import os
import shutil

def split_array(array, index):
    return array[:index], array[index:]



def get_class_name_from_yolo_txt(file_path):
    if 'classes' in file_path:
        a = 5
    else:
        with open(file_path, 'r') as f:
            lines = f.readlines()
            # The class name is the first element in the first line of the file
            class_idx = int(lines[0].split()[0])

            if(class_idx == 1 ):
                frame = file_path.replace('txt', 'png')
                return frame
            return 0

def check_folder(folder_path):
    
    if not os.path.exists(folder_path):
        os.makedirs(folder_path)
    else:
        print(f"{folder_path} already exists.")

def __init__():

    # Define the folder path where the frames are stored
    folder_path = './dataset-labeled/'
    


    sub_folder_list = os.listdir(folder_path)
    print(sub_folder_list)
    # Define the output video file name
    fps = 1

    for sub_folder in sub_folder_list:
        germinationFramePath = 0
        sub_folder_path = folder_path + sub_folder
        # Get the list of all frames in the folder
        labels = [f for f in os.listdir(sub_folder_path) if f.endswith('.txt')]
        frames = [f for f in os.listdir(sub_folder_path) if f.endswith('.png')]

        # # # Sort the frames based on their names
        # labels.sort()

        for count, label in enumerate(labels):
            data = get_class_name_from_yolo_txt(sub_folder_path + '/' + label)
            if(data != 0 and data != None):
                germinationFramePath = count
                break


        if(germinationFramePath - 1 >= 0):
            
            print(sub_folder)

            soilFrames, germFrames = split_array(frames, germinationFramePath - 1)

            out_frame_folder_germ = './frameDB/FA/' + sub_folder
            out_frame_folder_soil = './frameDB/Soil/' + sub_folder

            check_folder(out_frame_folder_germ)
            check_folder(out_frame_folder_soil)

           

            # Loop through all frames and add them to the video
            for frame_name in germFrames:
                src_path = sub_folder_path + '/' + frame_name
                dst_path = out_frame_folder_germ

                # print('src_path : ', src_path, " ----- ", 'dst_path :', dst_path)
                shutil.copy(src_path, dst_path)
            
            # Loop through all frames and add them to the video
            for frame_name in soilFrames:
                src_path = sub_folder_path + '/' + frame_name
                dst_path = out_frame_folder_soil + '/' + frame_name

                # print('src_path : ', src_path, " ----- ", 'dst_path :', dst_path)
                shutil.copy(src_path, dst_path)


__init__()