import os
import random
import shutil

# Define the percentage of images to use for the validation set
validation_pct = 0.2

# Get the list of image files
image_files = [f for f in os.listdir('images') if f.endswith('.png')]

# Shuffle the list of image files
random.shuffle(image_files)

# Split the image files into train and validation sets
split_idx = int(len(image_files) * validation_pct)
valid_files = image_files[:split_idx]
train_files = image_files[split_idx:]

# Create the train and validation folders
os.makedirs('train/images', exist_ok=True)
os.makedirs('train/labels', exist_ok=True)
os.makedirs('valid/images', exist_ok=True)
os.makedirs('valid/labels', exist_ok=True)

# Copy the image and label files to the appropriate folders
for f in train_files:
    # Copy the image file
    src_path = os.path.join('images', f)
    dest_path = os.path.join('train/images', f)
    shutil.copy(src_path, dest_path)

    # Copy the label file
    label_file = f.replace('.png', '.txt')
    src_path = os.path.join('labels', label_file)
    dest_path = os.path.join('train/labels', label_file)
    shutil.copy(src_path, dest_path)

for f in valid_files:
    # Copy the image file
    src_path = os.path.join('images', f)
    dest_path = os.path.join('valid/images', f)
    shutil.copy(src_path, dest_path)

    # Copy the label file
    label_file = f.replace('.png', '.txt')
    src_path = os.path.join('labels', label_file)
    dest_path = os.path.join('valid/labels', label_file)
    shutil.copy(src_path, dest_path)